
module speedtest1
using StaticArrays
using MeshCore: Locations, nvertices, coordinates, nshapes, skeleton, bbyfacets, manifdim, transpose
using MeshPorter: vtkwrite
using MeshMaker: T4block
using BenchmarkTools
using Test
function test()
    n = 3
    membytes = 0; summembytes = 0
    @info "Initial"
    @time connectivity = T4block(1.0, 2.0, 3.0, n*7, n*9, n*10, :a; intbytes = 4)
    @show (nshapes(connectivity.right), nshapes(connectivity.left))
    @show membytes = sizeof(connectivity._v)
    summembytes += membytes

    @info "Transpose"
    @time tconnectivity = transpose(connectivity)
    @show (nshapes(tconnectivity.right), nshapes(tconnectivity.left))
    @show membytes = sizeof(tconnectivity._v)
    summembytes += membytes

    @info "Skeleton"
    @time skel2 = skeleton(connectivity)
    @show (nshapes(skel2.right), nshapes(skel2.left))
    @show membytes = sizeof(skel2._v)
    summembytes += membytes

    @info "Skeleton"
    @time skel1 = skeleton(skel2)
    @show (nshapes(skel1.right), nshapes(skel1.left))
    @show membytes = sizeof(skel1._v)
    summembytes += membytes

    @info "Bounded-by facets"
    @time bb2 = bbyfacets(connectivity, skel2)
    @show (nshapes(bb2.right), nshapes(bb2.left))
    @show membytes = sizeof(bb2._v)
    summembytes += membytes

    @info "Bounded-by facets"
    @time bb1 = bbyfacets(skel2, skel1)
    @show (nshapes(bb1.right), nshapes(bb1.left))
    @show membytes = sizeof(bb1._v)
    summembytes += membytes
    @show summembytes

    # vtkwrite("speedtest1", connectivity)
    true
end
end
using .speedtest1
# using BenchmarkTools
# @btime speedtest1.test()
speedtest1.test()
